# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V2.Model.AccountStatusAccountLevelIssue do
  @moduledoc """


  ## Attributes

  *   `country` (*type:* `String.t`, *default:* `nil`) - Country for which this issue is reported.
  *   `destination` (*type:* `String.t`, *default:* `nil`) - The destination the issue applies to. If this field is empty then the issue applies to all available destinations.
  *   `detail` (*type:* `String.t`, *default:* `nil`) - Additional details about the issue.
  *   `documentation` (*type:* `String.t`, *default:* `nil`) - The URL of a web page to help resolving this issue.
  *   `id` (*type:* `String.t`, *default:* `nil`) - Issue identifier.
  *   `severity` (*type:* `String.t`, *default:* `nil`) - Severity of the issue. Acceptable values are: - "`critical`" - "`error`" - "`suggestion`" 
  *   `title` (*type:* `String.t`, *default:* `nil`) - Short description of the issue.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :country => String.t() | nil,
          :destination => String.t() | nil,
          :detail => String.t() | nil,
          :documentation => String.t() | nil,
          :id => String.t() | nil,
          :severity => String.t() | nil,
          :title => String.t() | nil
        }

  field(:country)
  field(:destination)
  field(:detail)
  field(:documentation)
  field(:id)
  field(:severity)
  field(:title)
end

defimpl Poison.Decoder, for: GoogleApi.Content.V2.Model.AccountStatusAccountLevelIssue do
  def decode(value, options) do
    GoogleApi.Content.V2.Model.AccountStatusAccountLevelIssue.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Content.V2.Model.AccountStatusAccountLevelIssue do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
