# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V2.Model.AccountStatusDataQualityIssue do
  @moduledoc """


  ## Attributes

  *   `country` (*type:* `String.t`, *default:* `nil`) - 
  *   `destination` (*type:* `String.t`, *default:* `nil`) - 
  *   `detail` (*type:* `String.t`, *default:* `nil`) - 
  *   `displayedValue` (*type:* `String.t`, *default:* `nil`) - 
  *   `exampleItems` (*type:* `list(GoogleApi.Content.V2.Model.AccountStatusExampleItem.t)`, *default:* `nil`) - 
  *   `id` (*type:* `String.t`, *default:* `nil`) - 
  *   `lastChecked` (*type:* `String.t`, *default:* `nil`) - 
  *   `location` (*type:* `String.t`, *default:* `nil`) - 
  *   `numItems` (*type:* `integer()`, *default:* `nil`) - 
  *   `severity` (*type:* `String.t`, *default:* `nil`) -  Acceptable values are: - "`critical`" - "`error`" - "`suggestion`" 
  *   `submittedValue` (*type:* `String.t`, *default:* `nil`) - 
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :country => String.t() | nil,
          :destination => String.t() | nil,
          :detail => String.t() | nil,
          :displayedValue => String.t() | nil,
          :exampleItems => list(GoogleApi.Content.V2.Model.AccountStatusExampleItem.t()) | nil,
          :id => String.t() | nil,
          :lastChecked => String.t() | nil,
          :location => String.t() | nil,
          :numItems => integer() | nil,
          :severity => String.t() | nil,
          :submittedValue => String.t() | nil
        }

  field(:country)
  field(:destination)
  field(:detail)
  field(:displayedValue)
  field(:exampleItems, as: GoogleApi.Content.V2.Model.AccountStatusExampleItem, type: :list)
  field(:id)
  field(:lastChecked)
  field(:location)
  field(:numItems)
  field(:severity)
  field(:submittedValue)
end

defimpl Poison.Decoder, for: GoogleApi.Content.V2.Model.AccountStatusDataQualityIssue do
  def decode(value, options) do
    GoogleApi.Content.V2.Model.AccountStatusDataQualityIssue.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Content.V2.Model.AccountStatusDataQualityIssue do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
