# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V2.Model.Error do
  @moduledoc """
  An error returned by the API.

  ## Attributes

  *   `domain` (*type:* `String.t`, *default:* `nil`) - The domain of the error.
  *   `message` (*type:* `String.t`, *default:* `nil`) - A description of the error.
  *   `reason` (*type:* `String.t`, *default:* `nil`) - The error code.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :domain => String.t() | nil,
          :message => String.t() | nil,
          :reason => String.t() | nil
        }

  field(:domain)
  field(:message)
  field(:reason)
end

defimpl Poison.Decoder, for: GoogleApi.Content.V2.Model.Error do
  def decode(value, options) do
    GoogleApi.Content.V2.Model.Error.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Content.V2.Model.Error do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
