# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V2.Model.Errors do
  @moduledoc """
  A list of errors returned by a failed batch entry.

  ## Attributes

  *   `code` (*type:* `integer()`, *default:* `nil`) - The HTTP status of the first error in `errors`.
  *   `errors` (*type:* `list(GoogleApi.Content.V2.Model.Error.t)`, *default:* `nil`) - A list of errors.
  *   `message` (*type:* `String.t`, *default:* `nil`) - The message of the first error in `errors`.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :code => integer() | nil,
          :errors => list(GoogleApi.Content.V2.Model.Error.t()) | nil,
          :message => String.t() | nil
        }

  field(:code)
  field(:errors, as: GoogleApi.Content.V2.Model.Error, type: :list)
  field(:message)
end

defimpl Poison.Decoder, for: GoogleApi.Content.V2.Model.Errors do
  def decode(value, options) do
    GoogleApi.Content.V2.Model.Errors.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Content.V2.Model.Errors do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
