# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V2.Model.OrderLineItemShippingDetailsMethod do
  @moduledoc """


  ## Attributes

  *   `carrier` (*type:* `String.t`, *default:* `nil`) - The carrier for the shipping. Optional. See `shipments[].carrier` for a list of acceptable values.
  *   `maxDaysInTransit` (*type:* `integer()`, *default:* `nil`) - Required. Maximum transit time.
  *   `methodName` (*type:* `String.t`, *default:* `nil`) - Required. The name of the shipping method.
  *   `minDaysInTransit` (*type:* `integer()`, *default:* `nil`) - Required. Minimum transit time.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :carrier => String.t() | nil,
          :maxDaysInTransit => integer() | nil,
          :methodName => String.t() | nil,
          :minDaysInTransit => integer() | nil
        }

  field(:carrier)
  field(:maxDaysInTransit)
  field(:methodName)
  field(:minDaysInTransit)
end

defimpl Poison.Decoder, for: GoogleApi.Content.V2.Model.OrderLineItemShippingDetailsMethod do
  def decode(value, options) do
    GoogleApi.Content.V2.Model.OrderLineItemShippingDetailsMethod.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Content.V2.Model.OrderLineItemShippingDetailsMethod do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
