# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V2.Model.OrderreportsListDisbursementsResponse do
  @moduledoc """


  ## Attributes

  *   `disbursements` (*type:* `list(GoogleApi.Content.V2.Model.OrderReportDisbursement.t)`, *default:* `nil`) - The list of disbursements.
  *   `kind` (*type:* `String.t`, *default:* `nil`) - Identifies what kind of resource this is. Value: the fixed string "content#orderreportsListDisbursementsResponse".
  *   `nextPageToken` (*type:* `String.t`, *default:* `nil`) - The token for the retrieval of the next page of disbursements.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :disbursements => list(GoogleApi.Content.V2.Model.OrderReportDisbursement.t()) | nil,
          :kind => String.t() | nil,
          :nextPageToken => String.t() | nil
        }

  field(:disbursements, as: GoogleApi.Content.V2.Model.OrderReportDisbursement, type: :list)
  field(:kind)
  field(:nextPageToken)
end

defimpl Poison.Decoder, for: GoogleApi.Content.V2.Model.OrderreportsListDisbursementsResponse do
  def decode(value, options) do
    GoogleApi.Content.V2.Model.OrderreportsListDisbursementsResponse.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Content.V2.Model.OrderreportsListDisbursementsResponse do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
