# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V2.Model.OrdersCustomBatchResponseEntry do
  @moduledoc """


  ## Attributes

  *   `batchId` (*type:* `integer()`, *default:* `nil`) - The ID of the request entry this entry responds to.
  *   `errors` (*type:* `GoogleApi.Content.V2.Model.Errors.t`, *default:* `nil`) - A list of errors defined if and only if the request failed.
  *   `executionStatus` (*type:* `String.t`, *default:* `nil`) - The status of the execution. Only defined if 1. the request was successful; and 2. the method is not `get`, `getByMerchantOrderId`, or one of the test methods. Acceptable values are: - "`duplicate`" - "`executed`" 
  *   `kind` (*type:* `String.t`, *default:* `nil`) - Identifies what kind of resource this is. Value: the fixed string "`content#ordersCustomBatchResponseEntry`"
  *   `order` (*type:* `GoogleApi.Content.V2.Model.Order.t`, *default:* `nil`) - The retrieved order. Only defined if the method is `get` and if the request was successful.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :batchId => integer() | nil,
          :errors => GoogleApi.Content.V2.Model.Errors.t() | nil,
          :executionStatus => String.t() | nil,
          :kind => String.t() | nil,
          :order => GoogleApi.Content.V2.Model.Order.t() | nil
        }

  field(:batchId)
  field(:errors, as: GoogleApi.Content.V2.Model.Errors)
  field(:executionStatus)
  field(:kind)
  field(:order, as: GoogleApi.Content.V2.Model.Order)
end

defimpl Poison.Decoder, for: GoogleApi.Content.V2.Model.OrdersCustomBatchResponseEntry do
  def decode(value, options) do
    GoogleApi.Content.V2.Model.OrdersCustomBatchResponseEntry.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Content.V2.Model.OrdersCustomBatchResponseEntry do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
