# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V2.Model.PostalCodeGroup do
  @moduledoc """


  ## Attributes

  *   `country` (*type:* `String.t`, *default:* `nil`) - The CLDR territory code of the country the postal code group applies to. Required.
  *   `name` (*type:* `String.t`, *default:* `nil`) - The name of the postal code group, referred to in headers. Required.
  *   `postalCodeRanges` (*type:* `list(GoogleApi.Content.V2.Model.PostalCodeRange.t)`, *default:* `nil`) - A range of postal codes. Required.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :country => String.t() | nil,
          :name => String.t() | nil,
          :postalCodeRanges => list(GoogleApi.Content.V2.Model.PostalCodeRange.t()) | nil
        }

  field(:country)
  field(:name)
  field(:postalCodeRanges, as: GoogleApi.Content.V2.Model.PostalCodeRange, type: :list)
end

defimpl Poison.Decoder, for: GoogleApi.Content.V2.Model.PostalCodeGroup do
  def decode(value, options) do
    GoogleApi.Content.V2.Model.PostalCodeGroup.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Content.V2.Model.PostalCodeGroup do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
