# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V2.Model.ProductStatusDestinationStatus do
  @moduledoc """


  ## Attributes

  *   `approvalPending` (*type:* `boolean()`, *default:* `nil`) - Whether the approval status might change due to further processing.
  *   `approvalStatus` (*type:* `String.t`, *default:* `nil`) - The destination's approval status. Acceptable values are: - "`approved`" - "`disapproved`" 
  *   `destination` (*type:* `String.t`, *default:* `nil`) - The name of the destination
  *   `intention` (*type:* `String.t`, *default:* `nil`) - Provided for backward compatibility only. Always set to "required". Acceptable values are: - "`default`" - "`excluded`" - "`optional`" - "`required`" 
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :approvalPending => boolean() | nil,
          :approvalStatus => String.t() | nil,
          :destination => String.t() | nil,
          :intention => String.t() | nil
        }

  field(:approvalPending)
  field(:approvalStatus)
  field(:destination)
  field(:intention)
end

defimpl Poison.Decoder, for: GoogleApi.Content.V2.Model.ProductStatusDestinationStatus do
  def decode(value, options) do
    GoogleApi.Content.V2.Model.ProductStatusDestinationStatus.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Content.V2.Model.ProductStatusDestinationStatus do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
