# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V2.Model.Promotion do
  @moduledoc """


  ## Attributes

  *   `promotionAmount` (*type:* `GoogleApi.Content.V2.Model.Amount.t`, *default:* `nil`) - [required] Amount of the promotion. The values here are the promotion applied to the unit price pretax and to the total of the tax amounts.
  *   `promotionId` (*type:* `String.t`, *default:* `nil`) - [required] ID of the promotion.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :promotionAmount => GoogleApi.Content.V2.Model.Amount.t() | nil,
          :promotionId => String.t() | nil
        }

  field(:promotionAmount, as: GoogleApi.Content.V2.Model.Amount)
  field(:promotionId)
end

defimpl Poison.Decoder, for: GoogleApi.Content.V2.Model.Promotion do
  def decode(value, options) do
    GoogleApi.Content.V2.Model.Promotion.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Content.V2.Model.Promotion do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
