# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V2.Model.ShippingsettingsCustomBatchRequestEntry do
  @moduledoc """
  A batch entry encoding a single non-batch shippingsettings request.

  ## Attributes

  *   `accountId` (*type:* `String.t`, *default:* `nil`) - The ID of the account for which to get/update account shipping settings.
  *   `batchId` (*type:* `integer()`, *default:* `nil`) - An entry ID, unique within the batch request.
  *   `merchantId` (*type:* `String.t`, *default:* `nil`) - The ID of the managing account.
  *   `method` (*type:* `String.t`, *default:* `nil`) - The method of the batch entry. Acceptable values are: - "`get`" - "`update`" 
  *   `shippingSettings` (*type:* `GoogleApi.Content.V2.Model.ShippingSettings.t`, *default:* `nil`) - The account shipping settings to update. Only defined if the method is `update`.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :accountId => String.t() | nil,
          :batchId => integer() | nil,
          :merchantId => String.t() | nil,
          :method => String.t() | nil,
          :shippingSettings => GoogleApi.Content.V2.Model.ShippingSettings.t() | nil
        }

  field(:accountId)
  field(:batchId)
  field(:merchantId)
  field(:method)
  field(:shippingSettings, as: GoogleApi.Content.V2.Model.ShippingSettings)
end

defimpl Poison.Decoder, for: GoogleApi.Content.V2.Model.ShippingsettingsCustomBatchRequestEntry do
  def decode(value, options) do
    GoogleApi.Content.V2.Model.ShippingsettingsCustomBatchRequestEntry.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Content.V2.Model.ShippingsettingsCustomBatchRequestEntry do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
