# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V21.Model.AccountItemUpdates do
  @moduledoc """
  Turning on [item updates](https://support.google.com/merchants/answer/3246284) allows Google to automatically update items for you. When item updates are on, Google uses the structured data markup on the website and advanced data extractors to update the price and availability of the items. When the item updates are off, items with mismatched data aren't shown.

  ## Attributes

  *   `accountItemUpdatesSettings` (*type:* `GoogleApi.Content.V21.Model.AccountItemUpdatesSettings.t`, *default:* `nil`) - Determines which attributes of the items should be automatically updated. If this field is not present, then the settings will be deleted. If there are no settings for subaccount, they are inherited from aggregator.
  *   `effectiveAllowAvailabilityUpdates` (*type:* `boolean()`, *default:* `nil`) - Output only. The effective value of allow_availability_updates. If account_item_updates_settings is present, then this value is the same. Otherwise, it represents the inherited value of the parent account. Read-only.
  *   `effectiveAllowPriceUpdates` (*type:* `boolean()`, *default:* `nil`) - Output only. The effective value of allow_price_updates. If account_item_updates_settings is present, then this value is the same. Otherwise, it represents the inherited value of the parent account. Read-only.
  *   `effectiveAllowStrictAvailabilityUpdates` (*type:* `boolean()`, *default:* `nil`) - Output only. The effective value of allow_strict_availability_updates. If account_item_updates_settings is present, then this value is the same. Otherwise, it represents the inherited value of the parent account. Read-only.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :accountItemUpdatesSettings =>
            GoogleApi.Content.V21.Model.AccountItemUpdatesSettings.t() | nil,
          :effectiveAllowAvailabilityUpdates => boolean() | nil,
          :effectiveAllowPriceUpdates => boolean() | nil,
          :effectiveAllowStrictAvailabilityUpdates => boolean() | nil
        }

  field(:accountItemUpdatesSettings, as: GoogleApi.Content.V21.Model.AccountItemUpdatesSettings)
  field(:effectiveAllowAvailabilityUpdates)
  field(:effectiveAllowPriceUpdates)
  field(:effectiveAllowStrictAvailabilityUpdates)
end

defimpl Poison.Decoder, for: GoogleApi.Content.V21.Model.AccountItemUpdates do
  def decode(value, options) do
    GoogleApi.Content.V21.Model.AccountItemUpdates.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Content.V21.Model.AccountItemUpdates do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
