# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V21.Model.AccountStatusStatistics do
  @moduledoc """


  ## Attributes

  *   `active` (*type:* `String.t`, *default:* `nil`) - Number of active offers.
  *   `disapproved` (*type:* `String.t`, *default:* `nil`) - Number of disapproved offers.
  *   `expiring` (*type:* `String.t`, *default:* `nil`) - Number of expiring offers.
  *   `pending` (*type:* `String.t`, *default:* `nil`) - Number of pending offers.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :active => String.t() | nil,
          :disapproved => String.t() | nil,
          :expiring => String.t() | nil,
          :pending => String.t() | nil
        }

  field(:active)
  field(:disapproved)
  field(:expiring)
  field(:pending)
end

defimpl Poison.Decoder, for: GoogleApi.Content.V21.Model.AccountStatusStatistics do
  def decode(value, options) do
    GoogleApi.Content.V21.Model.AccountStatusStatistics.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Content.V21.Model.AccountStatusStatistics do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
