# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V21.Model.CollectionFeaturedProduct do
  @moduledoc """
  The message for FeaturedProduct. [FeaturedProduct](https://support.google.com/merchants/answer/9703736)

  ## Attributes

  *   `offerId` (*type:* `String.t`, *default:* `nil`) - The unique identifier for the product item.
  *   `x` (*type:* `number()`, *default:* `nil`) - Required. X-coordinate of the product callout on the Shoppable Image.
  *   `y` (*type:* `number()`, *default:* `nil`) - Required. Y-coordinate of the product callout on the Shoppable Image.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :offerId => String.t() | nil,
          :x => number() | nil,
          :y => number() | nil
        }

  field(:offerId)
  field(:x)
  field(:y)
end

defimpl Poison.Decoder, for: GoogleApi.Content.V21.Model.CollectionFeaturedProduct do
  def decode(value, options) do
    GoogleApi.Content.V21.Model.CollectionFeaturedProduct.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Content.V21.Model.CollectionFeaturedProduct do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
