# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V21.Model.CollectionStatus do
  @moduledoc """
  The collectionstatus message.

  ## Attributes

  *   `collectionLevelIssuses` (*type:* `list(GoogleApi.Content.V21.Model.CollectionStatusItemLevelIssue.t)`, *default:* `nil`) - A list of all issues associated with the collection.
  *   `creationDate` (*type:* `String.t`, *default:* `nil`) - Date on which the collection has been created in [ISO 8601](http://en.wikipedia.org/wiki/ISO_8601) format: Date, time, and offset, e.g. "2020-01-02T09:00:00+01:00" or "2020-01-02T09:00:00Z"
  *   `destinationStatuses` (*type:* `list(GoogleApi.Content.V21.Model.CollectionStatusDestinationStatus.t)`, *default:* `nil`) - The intended destinations for the collection.
  *   `id` (*type:* `String.t`, *default:* `nil`) - Required. The ID of the collection for which status is reported.
  *   `lastUpdateDate` (*type:* `String.t`, *default:* `nil`) - Date on which the collection has been last updated in [ISO 8601](http://en.wikipedia.org/wiki/ISO_8601) format: Date, time, and offset, e.g. "2020-01-02T09:00:00+01:00" or "2020-01-02T09:00:00Z"
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :collectionLevelIssuses =>
            list(GoogleApi.Content.V21.Model.CollectionStatusItemLevelIssue.t()) | nil,
          :creationDate => String.t() | nil,
          :destinationStatuses =>
            list(GoogleApi.Content.V21.Model.CollectionStatusDestinationStatus.t()) | nil,
          :id => String.t() | nil,
          :lastUpdateDate => String.t() | nil
        }

  field(:collectionLevelIssuses,
    as: GoogleApi.Content.V21.Model.CollectionStatusItemLevelIssue,
    type: :list
  )

  field(:creationDate)

  field(:destinationStatuses,
    as: GoogleApi.Content.V21.Model.CollectionStatusDestinationStatus,
    type: :list
  )

  field(:id)
  field(:lastUpdateDate)
end

defimpl Poison.Decoder, for: GoogleApi.Content.V21.Model.CollectionStatus do
  def decode(value, options) do
    GoogleApi.Content.V21.Model.CollectionStatus.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Content.V21.Model.CollectionStatus do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
