# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V21.Model.Css do
  @moduledoc """
  Information about CSS domain.

  ## Attributes

  *   `cssDomainId` (*type:* `String.t`, *default:* `nil`) - Output only. Immutable. The CSS domain ID.
  *   `cssGroupId` (*type:* `String.t`, *default:* `nil`) - Output only. Immutable. The ID of the CSS group this CSS domain is affiliated with. Only populated for CSS group users.
  *   `displayName` (*type:* `String.t`, *default:* `nil`) - Output only. Immutable. The CSS domain's display name, used when space is constrained.
  *   `fullName` (*type:* `String.t`, *default:* `nil`) - Output only. Immutable. The CSS domain's full name.
  *   `homepageUri` (*type:* `String.t`, *default:* `nil`) - Output only. Immutable. The CSS domain's homepage.
  *   `labelIds` (*type:* `list(String.t)`, *default:* `nil`) - A list of label IDs that are assigned to this CSS domain by its CSS group. Only populated for CSS group users.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :cssDomainId => String.t() | nil,
          :cssGroupId => String.t() | nil,
          :displayName => String.t() | nil,
          :fullName => String.t() | nil,
          :homepageUri => String.t() | nil,
          :labelIds => list(String.t()) | nil
        }

  field(:cssDomainId)
  field(:cssGroupId)
  field(:displayName)
  field(:fullName)
  field(:homepageUri)
  field(:labelIds, type: :list)
end

defimpl Poison.Decoder, for: GoogleApi.Content.V21.Model.Css do
  def decode(value, options) do
    GoogleApi.Content.V21.Model.Css.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Content.V21.Model.Css do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
