# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V21.Model.CustomAttribute do
  @moduledoc """


  ## Attributes

  *   `groupValues` (*type:* `list(GoogleApi.Content.V21.Model.CustomAttribute.t)`, *default:* `nil`) - Subattributes within this attribute group. Exactly one of value or groupValues must be provided.
  *   `name` (*type:* `String.t`, *default:* `nil`) - The name of the attribute. Underscores will be replaced by spaces upon insertion.
  *   `value` (*type:* `String.t`, *default:* `nil`) - The value of the attribute.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :groupValues => list(GoogleApi.Content.V21.Model.CustomAttribute.t()) | nil,
          :name => String.t() | nil,
          :value => String.t() | nil
        }

  field(:groupValues, as: GoogleApi.Content.V21.Model.CustomAttribute, type: :list)
  field(:name)
  field(:value)
end

defimpl Poison.Decoder, for: GoogleApi.Content.V21.Model.CustomAttribute do
  def decode(value, options) do
    GoogleApi.Content.V21.Model.CustomAttribute.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Content.V21.Model.CustomAttribute do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
