# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V21.Model.DatafeedFormat do
  @moduledoc """


  ## Attributes

  *   `columnDelimiter` (*type:* `String.t`, *default:* `nil`) - Delimiter for the separation of values in a delimiter-separated values feed. If not specified, the delimiter will be auto-detected. Ignored for non-DSV data feeds. Acceptable values are: - "`pipe`" - "`tab`" - "`tilde`" 
  *   `fileEncoding` (*type:* `String.t`, *default:* `nil`) - Character encoding scheme of the data feed. If not specified, the encoding will be auto-detected. Acceptable values are: - "`latin-1`" - "`utf-16be`" - "`utf-16le`" - "`utf-8`" - "`windows-1252`" 
  *   `quotingMode` (*type:* `String.t`, *default:* `nil`) - Specifies how double quotes are interpreted. If not specified, the mode will be auto-detected. Ignored for non-DSV data feeds. Acceptable values are: - "`normal character`" - "`value quoting`" 
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :columnDelimiter => String.t() | nil,
          :fileEncoding => String.t() | nil,
          :quotingMode => String.t() | nil
        }

  field(:columnDelimiter)
  field(:fileEncoding)
  field(:quotingMode)
end

defimpl Poison.Decoder, for: GoogleApi.Content.V21.Model.DatafeedFormat do
  def decode(value, options) do
    GoogleApi.Content.V21.Model.DatafeedFormat.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Content.V21.Model.DatafeedFormat do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
