# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V21.Model.LinkService do
  @moduledoc """


  ## Attributes

  *   `service` (*type:* `String.t`, *default:* `nil`) - Service provided to or by the linked account. Acceptable values are: - "`shoppingActionsOrderManagement`" - "`shoppingActionsProductManagement`" - "`shoppingAdsProductManagement`" - "`paymentProcessing`" 
  *   `status` (*type:* `String.t`, *default:* `nil`) - Status of the link Acceptable values are: - "`active`" - "`inactive`" - "`pending`" 
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :service => String.t() | nil,
          :status => String.t() | nil
        }

  field(:service)
  field(:status)
end

defimpl Poison.Decoder, for: GoogleApi.Content.V21.Model.LinkService do
  def decode(value, options) do
    GoogleApi.Content.V21.Model.LinkService.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Content.V21.Model.LinkService do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
