# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V21.Model.ListRepricingRuleReportsResponse do
  @moduledoc """
  Response message for the ListRepricingRuleReports method.

  ## Attributes

  *   `nextPageToken` (*type:* `String.t`, *default:* `nil`) - A token for retrieving the next page. Its absence means there is no subsequent page.
  *   `repricingRuleReports` (*type:* `list(GoogleApi.Content.V21.Model.RepricingRuleReport.t)`, *default:* `nil`) - Daily reports for the given Repricing rule.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :nextPageToken => String.t() | nil,
          :repricingRuleReports => list(GoogleApi.Content.V21.Model.RepricingRuleReport.t()) | nil
        }

  field(:nextPageToken)
  field(:repricingRuleReports, as: GoogleApi.Content.V21.Model.RepricingRuleReport, type: :list)
end

defimpl Poison.Decoder, for: GoogleApi.Content.V21.Model.ListRepricingRuleReportsResponse do
  def decode(value, options) do
    GoogleApi.Content.V21.Model.ListRepricingRuleReportsResponse.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Content.V21.Model.ListRepricingRuleReportsResponse do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
