# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V21.Model.MinimumOrderValueTableStoreCodeSetWithMov do
  @moduledoc """
  A list of store code sets sharing the same minimum order value. At least two sets are required and the last one must be empty, which signifies 'MOV for all other stores'. Each store code can only appear once across all the sets. All prices within a service must have the same currency.

  ## Attributes

  *   `storeCodes` (*type:* `list(String.t)`, *default:* `nil`) - A list of unique store codes or empty for the catch all.
  *   `value` (*type:* `GoogleApi.Content.V21.Model.Price.t`, *default:* `nil`) - The minimum order value for the given stores.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :storeCodes => list(String.t()) | nil,
          :value => GoogleApi.Content.V21.Model.Price.t() | nil
        }

  field(:storeCodes, type: :list)
  field(:value, as: GoogleApi.Content.V21.Model.Price)
end

defimpl Poison.Decoder, for: GoogleApi.Content.V21.Model.MinimumOrderValueTableStoreCodeSetWithMov do
  def decode(value, options) do
    GoogleApi.Content.V21.Model.MinimumOrderValueTableStoreCodeSetWithMov.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Content.V21.Model.MinimumOrderValueTableStoreCodeSetWithMov do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
