# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V21.Model.MonetaryAmount do
  @moduledoc """


  ## Attributes

  *   `priceAmount` (*type:* `GoogleApi.Content.V21.Model.Price.t`, *default:* `nil`) - The pre-tax or post-tax price depends on the location of the order. - For countries (e.g. US) where price attribute excludes tax, this field corresponds to the pre-tax value. - For coutries (e.g. France) where price attribute includes tax, this field corresponds to the post-tax value .
  *   `taxAmount` (*type:* `GoogleApi.Content.V21.Model.Price.t`, *default:* `nil`) - Tax value, present only for countries where price attribute excludes tax (e.g. US). No tax is referenced as 0 value with the corresponding `currency`.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :priceAmount => GoogleApi.Content.V21.Model.Price.t() | nil,
          :taxAmount => GoogleApi.Content.V21.Model.Price.t() | nil
        }

  field(:priceAmount, as: GoogleApi.Content.V21.Model.Price)
  field(:taxAmount, as: GoogleApi.Content.V21.Model.Price)
end

defimpl Poison.Decoder, for: GoogleApi.Content.V21.Model.MonetaryAmount do
  def decode(value, options) do
    GoogleApi.Content.V21.Model.MonetaryAmount.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Content.V21.Model.MonetaryAmount do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
