# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V21.Model.OrderLineItemAdjustment do
  @moduledoc """


  ## Attributes

  *   `priceAdjustment` (*type:* `GoogleApi.Content.V21.Model.Price.t`, *default:* `nil`) - Adjustment for total price of the line item.
  *   `taxAdjustment` (*type:* `GoogleApi.Content.V21.Model.Price.t`, *default:* `nil`) - Adjustment for total tax of the line item.
  *   `type` (*type:* `String.t`, *default:* `nil`) - Type of this adjustment. Acceptable values are: - "`promotion`" 
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :priceAdjustment => GoogleApi.Content.V21.Model.Price.t() | nil,
          :taxAdjustment => GoogleApi.Content.V21.Model.Price.t() | nil,
          :type => String.t() | nil
        }

  field(:priceAdjustment, as: GoogleApi.Content.V21.Model.Price)
  field(:taxAdjustment, as: GoogleApi.Content.V21.Model.Price)
  field(:type)
end

defimpl Poison.Decoder, for: GoogleApi.Content.V21.Model.OrderLineItemAdjustment do
  def decode(value, options) do
    GoogleApi.Content.V21.Model.OrderLineItemAdjustment.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Content.V21.Model.OrderLineItemAdjustment do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
