# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V21.Model.OrderreturnsRefundOperation do
  @moduledoc """


  ## Attributes

  *   `fullRefund` (*type:* `boolean()`, *default:* `nil`) - If true, the item will be fully refunded. Allowed only when payment_type is FOP. Merchant can choose this refund option to indicate the full remaining amount of corresponding object to be refunded to the customer via FOP.
  *   `partialRefund` (*type:* `GoogleApi.Content.V21.Model.OrderreturnsPartialRefund.t`, *default:* `nil`) - If this is set, the item will be partially refunded. Merchant can choose this refund option to specify the customized amount that to be refunded to the customer.
  *   `paymentType` (*type:* `String.t`, *default:* `nil`) - The payment way of issuing refund. Default value is ORIGINAL_FOP if not set.
  *   `reasonText` (*type:* `String.t`, *default:* `nil`) - The explanation of the reason.
  *   `returnRefundReason` (*type:* `String.t`, *default:* `nil`) - Code of the refund reason.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :fullRefund => boolean() | nil,
          :partialRefund => GoogleApi.Content.V21.Model.OrderreturnsPartialRefund.t() | nil,
          :paymentType => String.t() | nil,
          :reasonText => String.t() | nil,
          :returnRefundReason => String.t() | nil
        }

  field(:fullRefund)
  field(:partialRefund, as: GoogleApi.Content.V21.Model.OrderreturnsPartialRefund)
  field(:paymentType)
  field(:reasonText)
  field(:returnRefundReason)
end

defimpl Poison.Decoder, for: GoogleApi.Content.V21.Model.OrderreturnsRefundOperation do
  def decode(value, options) do
    GoogleApi.Content.V21.Model.OrderreturnsRefundOperation.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Content.V21.Model.OrderreturnsRefundOperation do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
