# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V21.Model.OrderreturnsReturnItem do
  @moduledoc """


  ## Attributes

  *   `refund` (*type:* `GoogleApi.Content.V21.Model.OrderreturnsRefundOperation.t`, *default:* `nil`) - Refunds the item.
  *   `reject` (*type:* `GoogleApi.Content.V21.Model.OrderreturnsRejectOperation.t`, *default:* `nil`) - Rejects the item.
  *   `returnItemId` (*type:* `String.t`, *default:* `nil`) - Unit level ID for the return item. Different units of the same product will have different IDs.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :refund => GoogleApi.Content.V21.Model.OrderreturnsRefundOperation.t() | nil,
          :reject => GoogleApi.Content.V21.Model.OrderreturnsRejectOperation.t() | nil,
          :returnItemId => String.t() | nil
        }

  field(:refund, as: GoogleApi.Content.V21.Model.OrderreturnsRefundOperation)
  field(:reject, as: GoogleApi.Content.V21.Model.OrderreturnsRejectOperation)
  field(:returnItemId)
end

defimpl Poison.Decoder, for: GoogleApi.Content.V21.Model.OrderreturnsReturnItem do
  def decode(value, options) do
    GoogleApi.Content.V21.Model.OrderreturnsReturnItem.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Content.V21.Model.OrderreturnsReturnItem do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
