# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V21.Model.OrdersCustomBatchRequestEntryRefundItemShipping do
  @moduledoc """


  ## Attributes

  *   `amount` (*type:* `GoogleApi.Content.V21.Model.Price.t`, *default:* `nil`) - The amount that is refunded. If this is not the first refund for the shipment, this should be the newly refunded amount.
  *   `fullRefund` (*type:* `boolean()`, *default:* `nil`) - If set to true, all shipping costs for the order will be refunded. If this is true, amount should not be provided and will be ignored. If set to false, submit the amount of the partial shipping refund, excluding the shipping tax. The shipping tax is calculated and handled on Google's side.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :amount => GoogleApi.Content.V21.Model.Price.t() | nil,
          :fullRefund => boolean() | nil
        }

  field(:amount, as: GoogleApi.Content.V21.Model.Price)
  field(:fullRefund)
end

defimpl Poison.Decoder,
  for: GoogleApi.Content.V21.Model.OrdersCustomBatchRequestEntryRefundItemShipping do
  def decode(value, options) do
    GoogleApi.Content.V21.Model.OrdersCustomBatchRequestEntryRefundItemShipping.decode(
      value,
      options
    )
  end
end

defimpl Poison.Encoder,
  for: GoogleApi.Content.V21.Model.OrdersCustomBatchRequestEntryRefundItemShipping do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
