# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V21.Model.OrdersRefundOrderRequest do
  @moduledoc """


  ## Attributes

  *   `amount` (*type:* `GoogleApi.Content.V21.Model.MonetaryAmount.t`, *default:* `nil`) - The amount that is refunded. If this is not the first refund for the order, this should be the newly refunded amount.
  *   `fullRefund` (*type:* `boolean()`, *default:* `nil`) - If true, the full order will be refunded, including shipping. If this is true, amount should not be provided and will be ignored.
  *   `operationId` (*type:* `String.t`, *default:* `nil`) - The ID of the operation. Unique across all operations for a given order.
  *   `reason` (*type:* `String.t`, *default:* `nil`) - The reason for the refund. Acceptable values are: - "`courtesyAdjustment`" - "`other`" 
  *   `reasonText` (*type:* `String.t`, *default:* `nil`) - The explanation of the reason.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :amount => GoogleApi.Content.V21.Model.MonetaryAmount.t() | nil,
          :fullRefund => boolean() | nil,
          :operationId => String.t() | nil,
          :reason => String.t() | nil,
          :reasonText => String.t() | nil
        }

  field(:amount, as: GoogleApi.Content.V21.Model.MonetaryAmount)
  field(:fullRefund)
  field(:operationId)
  field(:reason)
  field(:reasonText)
end

defimpl Poison.Decoder, for: GoogleApi.Content.V21.Model.OrdersRefundOrderRequest do
  def decode(value, options) do
    GoogleApi.Content.V21.Model.OrdersRefundOrderRequest.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Content.V21.Model.OrdersRefundOrderRequest do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
