# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V21.Model.OrdersShipLineItemsRequest do
  @moduledoc """


  ## Attributes

  *   `lineItems` (*type:* `list(GoogleApi.Content.V21.Model.OrderShipmentLineItemShipment.t)`, *default:* `nil`) - Line items to ship.
  *   `operationId` (*type:* `String.t`, *default:* `nil`) - The ID of the operation. Unique across all operations for a given order.
  *   `shipmentGroupId` (*type:* `String.t`, *default:* `nil`) - ID of the shipment group. Required for orders that use the orderinvoices service.
  *   `shipmentInfos` (*type:* `list(GoogleApi.Content.V21.Model.OrdersCustomBatchRequestEntryShipLineItemsShipmentInfo.t)`, *default:* `nil`) - Shipment information. This field is repeated because a single line item can be shipped in several packages (and have several tracking IDs).
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :lineItems => list(GoogleApi.Content.V21.Model.OrderShipmentLineItemShipment.t()) | nil,
          :operationId => String.t() | nil,
          :shipmentGroupId => String.t() | nil,
          :shipmentInfos =>
            list(
              GoogleApi.Content.V21.Model.OrdersCustomBatchRequestEntryShipLineItemsShipmentInfo.t()
            )
            | nil
        }

  field(:lineItems, as: GoogleApi.Content.V21.Model.OrderShipmentLineItemShipment, type: :list)
  field(:operationId)
  field(:shipmentGroupId)

  field(:shipmentInfos,
    as: GoogleApi.Content.V21.Model.OrdersCustomBatchRequestEntryShipLineItemsShipmentInfo,
    type: :list
  )
end

defimpl Poison.Decoder, for: GoogleApi.Content.V21.Model.OrdersShipLineItemsRequest do
  def decode(value, options) do
    GoogleApi.Content.V21.Model.OrdersShipLineItemsRequest.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Content.V21.Model.OrdersShipLineItemsRequest do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
