# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V21.Model.OrdersUpdateLineItemShippingDetailsRequest do
  @moduledoc """


  ## Attributes

  *   `deliverByDate` (*type:* `String.t`, *default:* `nil`) - Updated delivery by date, in ISO 8601 format. If not specified only ship by date is updated. Provided date should be within 1 year timeframe and can not be a date in the past.
  *   `lineItemId` (*type:* `String.t`, *default:* `nil`) - The ID of the line item to set metadata. Either lineItemId or productId is required.
  *   `operationId` (*type:* `String.t`, *default:* `nil`) - The ID of the operation. Unique across all operations for a given order.
  *   `productId` (*type:* `String.t`, *default:* `nil`) - The ID of the product to set metadata. This is the REST ID used in the products service. Either lineItemId or productId is required.
  *   `shipByDate` (*type:* `String.t`, *default:* `nil`) - Updated ship by date, in ISO 8601 format. If not specified only deliver by date is updated. Provided date should be within 1 year timeframe and can not be a date in the past.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :deliverByDate => String.t() | nil,
          :lineItemId => String.t() | nil,
          :operationId => String.t() | nil,
          :productId => String.t() | nil,
          :shipByDate => String.t() | nil
        }

  field(:deliverByDate)
  field(:lineItemId)
  field(:operationId)
  field(:productId)
  field(:shipByDate)
end

defimpl Poison.Decoder,
  for: GoogleApi.Content.V21.Model.OrdersUpdateLineItemShippingDetailsRequest do
  def decode(value, options) do
    GoogleApi.Content.V21.Model.OrdersUpdateLineItemShippingDetailsRequest.decode(value, options)
  end
end

defimpl Poison.Encoder,
  for: GoogleApi.Content.V21.Model.OrdersUpdateLineItemShippingDetailsRequest do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
