# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V21.Model.OrdersUpdateMerchantOrderIdRequest do
  @moduledoc """


  ## Attributes

  *   `merchantOrderId` (*type:* `String.t`, *default:* `nil`) - The merchant order id to be assigned to the order. Must be unique per merchant.
  *   `operationId` (*type:* `String.t`, *default:* `nil`) - The ID of the operation. Unique across all operations for a given order.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :merchantOrderId => String.t() | nil,
          :operationId => String.t() | nil
        }

  field(:merchantOrderId)
  field(:operationId)
end

defimpl Poison.Decoder, for: GoogleApi.Content.V21.Model.OrdersUpdateMerchantOrderIdRequest do
  def decode(value, options) do
    GoogleApi.Content.V21.Model.OrdersUpdateMerchantOrderIdRequest.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Content.V21.Model.OrdersUpdateMerchantOrderIdRequest do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
