# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V21.Model.OrdersUpdateShipmentRequest do
  @moduledoc """


  ## Attributes

  *   `carrier` (*type:* `String.t`, *default:* `nil`) - The carrier handling the shipment. Not updated if missing. See `shipments[].carrier` in the Orders resource representation for a list of acceptable values.
  *   `deliveryDate` (*type:* `String.t`, *default:* `nil`) - Date on which the shipment has been delivered, in ISO 8601 format. Optional and can be provided only if `status` is `delivered`.
  *   `lastPickupDate` (*type:* `String.t`, *default:* `nil`) - Date after which the pickup will expire, in ISO 8601 format. Required only when order is buy-online-pickup-in-store(BOPIS) and `status` is `ready for pickup`.
  *   `operationId` (*type:* `String.t`, *default:* `nil`) - The ID of the operation. Unique across all operations for a given order.
  *   `readyPickupDate` (*type:* `String.t`, *default:* `nil`) - Date on which the shipment has been ready for pickup, in ISO 8601 format. Optional and can be provided only if `status` is `ready for pickup`.
  *   `scheduledDeliveryDetails` (*type:* `GoogleApi.Content.V21.Model.OrdersCustomBatchRequestEntryUpdateShipmentScheduledDeliveryDetails.t`, *default:* `nil`) - Delivery details of the shipment if scheduling is needed.
  *   `shipmentId` (*type:* `String.t`, *default:* `nil`) - The ID of the shipment.
  *   `status` (*type:* `String.t`, *default:* `nil`) - New status for the shipment. Not updated if missing. Acceptable values are: - "`delivered`" - "`undeliverable`" - "`readyForPickup`" 
  *   `trackingId` (*type:* `String.t`, *default:* `nil`) - The tracking ID for the shipment. Not updated if missing.
  *   `undeliveredDate` (*type:* `String.t`, *default:* `nil`) - Date on which the shipment has been undeliverable, in ISO 8601 format. Optional and can be provided only if `status` is `undeliverable`.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :carrier => String.t() | nil,
          :deliveryDate => String.t() | nil,
          :lastPickupDate => String.t() | nil,
          :operationId => String.t() | nil,
          :readyPickupDate => String.t() | nil,
          :scheduledDeliveryDetails =>
            GoogleApi.Content.V21.Model.OrdersCustomBatchRequestEntryUpdateShipmentScheduledDeliveryDetails.t()
            | nil,
          :shipmentId => String.t() | nil,
          :status => String.t() | nil,
          :trackingId => String.t() | nil,
          :undeliveredDate => String.t() | nil
        }

  field(:carrier)
  field(:deliveryDate)
  field(:lastPickupDate)
  field(:operationId)
  field(:readyPickupDate)

  field(:scheduledDeliveryDetails,
    as:
      GoogleApi.Content.V21.Model.OrdersCustomBatchRequestEntryUpdateShipmentScheduledDeliveryDetails
  )

  field(:shipmentId)
  field(:status)
  field(:trackingId)
  field(:undeliveredDate)
end

defimpl Poison.Decoder, for: GoogleApi.Content.V21.Model.OrdersUpdateShipmentRequest do
  def decode(value, options) do
    GoogleApi.Content.V21.Model.OrdersUpdateShipmentRequest.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Content.V21.Model.OrdersUpdateShipmentRequest do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
