# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V21.Model.PosStore do
  @moduledoc """
  Store resource.

  ## Attributes

  *   `gcidCategory` (*type:* `list(String.t)`, *default:* `nil`) - The business type of the store.
  *   `kind` (*type:* `String.t`, *default:* `nil`) - Identifies what kind of resource this is. Value: the fixed string "`content#posStore`"
  *   `phoneNumber` (*type:* `String.t`, *default:* `nil`) - The store phone number.
  *   `placeId` (*type:* `String.t`, *default:* `nil`) - The Google Place Id of the store location.
  *   `storeAddress` (*type:* `String.t`, *default:* `nil`) - Required. The street address of the store.
  *   `storeCode` (*type:* `String.t`, *default:* `nil`) - Required. A store identifier that is unique for the given merchant.
  *   `storeName` (*type:* `String.t`, *default:* `nil`) - The merchant or store name.
  *   `websiteUrl` (*type:* `String.t`, *default:* `nil`) - The website url for the store or merchant.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :gcidCategory => list(String.t()) | nil,
          :kind => String.t() | nil,
          :phoneNumber => String.t() | nil,
          :placeId => String.t() | nil,
          :storeAddress => String.t() | nil,
          :storeCode => String.t() | nil,
          :storeName => String.t() | nil,
          :websiteUrl => String.t() | nil
        }

  field(:gcidCategory, type: :list)
  field(:kind)
  field(:phoneNumber)
  field(:placeId)
  field(:storeAddress)
  field(:storeCode)
  field(:storeName)
  field(:websiteUrl)
end

defimpl Poison.Decoder, for: GoogleApi.Content.V21.Model.PosStore do
  def decode(value, options) do
    GoogleApi.Content.V21.Model.PosStore.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Content.V21.Model.PosStore do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
