# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V21.Model.ProductStatusDestinationStatus do
  @moduledoc """


  ## Attributes

  *   `approvedCountries` (*type:* `list(String.t)`, *default:* `nil`) - List of country codes (ISO 3166-1 alpha-2) where the offer is approved.
  *   `destination` (*type:* `String.t`, *default:* `nil`) - The name of the destination
  *   `disapprovedCountries` (*type:* `list(String.t)`, *default:* `nil`) - List of country codes (ISO 3166-1 alpha-2) where the offer is disapproved.
  *   `pendingCountries` (*type:* `list(String.t)`, *default:* `nil`) - List of country codes (ISO 3166-1 alpha-2) where the offer is pending approval.
  *   `status` (*type:* `String.t`, *default:* `nil`) - Destination approval status in `targetCountry` of the offer.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :approvedCountries => list(String.t()) | nil,
          :destination => String.t() | nil,
          :disapprovedCountries => list(String.t()) | nil,
          :pendingCountries => list(String.t()) | nil,
          :status => String.t() | nil
        }

  field(:approvedCountries, type: :list)
  field(:destination)
  field(:disapprovedCountries, type: :list)
  field(:pendingCountries, type: :list)
  field(:status)
end

defimpl Poison.Decoder, for: GoogleApi.Content.V21.Model.ProductStatusDestinationStatus do
  def decode(value, options) do
    GoogleApi.Content.V21.Model.ProductStatusDestinationStatus.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Content.V21.Model.ProductStatusDestinationStatus do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
