# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V21.Model.RepricingProductReportBuyboxWinningProductStats do
  @moduledoc """
  Stats specific to buybox winning rules for product report.

  ## Attributes

  *   `buyboxWinsCount` (*type:* `integer()`, *default:* `nil`) - Number of times this product won the buybox with these rules during this time period.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :buyboxWinsCount => integer() | nil
        }

  field(:buyboxWinsCount)
end

defimpl Poison.Decoder,
  for: GoogleApi.Content.V21.Model.RepricingProductReportBuyboxWinningProductStats do
  def decode(value, options) do
    GoogleApi.Content.V21.Model.RepricingProductReportBuyboxWinningProductStats.decode(
      value,
      options
    )
  end
end

defimpl Poison.Encoder,
  for: GoogleApi.Content.V21.Model.RepricingProductReportBuyboxWinningProductStats do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
