# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V21.Model.RequestReviewShoppingAdsRequest do
  @moduledoc """
  Request message for the RequestReviewShoppingAds program method.

  ## Attributes

  *   `regionCode` (*type:* `String.t`, *default:* `nil`) - The code [ISO 3166-1 alpha-2](https://en.wikipedia.org/wiki/ISO_3166-1_alpha-2) of the country for which review is to be requested.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :regionCode => String.t() | nil
        }

  field(:regionCode)
end

defimpl Poison.Decoder, for: GoogleApi.Content.V21.Model.RequestReviewShoppingAdsRequest do
  def decode(value, options) do
    GoogleApi.Content.V21.Model.RequestReviewShoppingAdsRequest.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Content.V21.Model.RequestReviewShoppingAdsRequest do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
