# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V21.Model.ReturnAddress do
  @moduledoc """
  Return address resource.

  ## Attributes

  *   `address` (*type:* `GoogleApi.Content.V21.Model.ReturnAddressAddress.t`, *default:* `nil`) - Required. The address.
  *   `country` (*type:* `String.t`, *default:* `nil`) - Required. The country of sale where the return address is applicable.
  *   `kind` (*type:* `String.t`, *default:* `nil`) - Identifies what kind of resource this is. Value: the fixed string "`content#returnAddress`"
  *   `label` (*type:* `String.t`, *default:* `nil`) - Required. The user-defined label of the return address. For the default address, use the label "default".
  *   `phoneNumber` (*type:* `String.t`, *default:* `nil`) - Required. The merchant's contact phone number regarding the return.
  *   `returnAddressId` (*type:* `String.t`, *default:* `nil`) - Return address ID generated by Google.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :address => GoogleApi.Content.V21.Model.ReturnAddressAddress.t() | nil,
          :country => String.t() | nil,
          :kind => String.t() | nil,
          :label => String.t() | nil,
          :phoneNumber => String.t() | nil,
          :returnAddressId => String.t() | nil
        }

  field(:address, as: GoogleApi.Content.V21.Model.ReturnAddressAddress)
  field(:country)
  field(:kind)
  field(:label)
  field(:phoneNumber)
  field(:returnAddressId)
end

defimpl Poison.Decoder, for: GoogleApi.Content.V21.Model.ReturnAddress do
  def decode(value, options) do
    GoogleApi.Content.V21.Model.ReturnAddress.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Content.V21.Model.ReturnAddress do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
