# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V21.Model.ReturnPolicyOnlineReturnReasonCategoryInfo do
  @moduledoc """
  The return reason category info wrapper.

  ## Attributes

  *   `returnLabelSource` (*type:* `String.t`, *default:* `nil`) - The corresponding return label source.
  *   `returnReasonCategory` (*type:* `String.t`, *default:* `nil`) - The return reason category.
  *   `returnShippingFee` (*type:* `GoogleApi.Content.V21.Model.ReturnPolicyOnlineReturnShippingFee.t`, *default:* `nil`) - The corresponding return shipping fee. This is only applicable when returnLabelSource is not the customer's responsibility.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :returnLabelSource => String.t() | nil,
          :returnReasonCategory => String.t() | nil,
          :returnShippingFee =>
            GoogleApi.Content.V21.Model.ReturnPolicyOnlineReturnShippingFee.t() | nil
        }

  field(:returnLabelSource)
  field(:returnReasonCategory)
  field(:returnShippingFee, as: GoogleApi.Content.V21.Model.ReturnPolicyOnlineReturnShippingFee)
end

defimpl Poison.Decoder,
  for: GoogleApi.Content.V21.Model.ReturnPolicyOnlineReturnReasonCategoryInfo do
  def decode(value, options) do
    GoogleApi.Content.V21.Model.ReturnPolicyOnlineReturnReasonCategoryInfo.decode(value, options)
  end
end

defimpl Poison.Encoder,
  for: GoogleApi.Content.V21.Model.ReturnPolicyOnlineReturnReasonCategoryInfo do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
