# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V21.Model.ReturnPolicyOnlineReturnShippingFee do
  @moduledoc """
  The return shipping fee. This can either be a fixed fee or a boolean to indicate that the customer pays the actual shipping cost.

  ## Attributes

  *   `fixedFee` (*type:* `GoogleApi.Content.V21.Model.PriceAmount.t`, *default:* `nil`) - Fixed return shipping fee amount. This value is only applicable when type is FIXED. We will treat the return shipping fee as free if type is FIXED and this value is not set.
  *   `type` (*type:* `String.t`, *default:* `nil`) - Type of return shipping fee.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :fixedFee => GoogleApi.Content.V21.Model.PriceAmount.t() | nil,
          :type => String.t() | nil
        }

  field(:fixedFee, as: GoogleApi.Content.V21.Model.PriceAmount)
  field(:type)
end

defimpl Poison.Decoder, for: GoogleApi.Content.V21.Model.ReturnPolicyOnlineReturnShippingFee do
  def decode(value, options) do
    GoogleApi.Content.V21.Model.ReturnPolicyOnlineReturnShippingFee.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Content.V21.Model.ReturnPolicyOnlineReturnShippingFee do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
