# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V21.Model.ReturnShippingLabel do
  @moduledoc """
  Return shipping label for a Buy on Google merchant-managed return.

  ## Attributes

  *   `carrier` (*type:* `String.t`, *default:* `nil`) - Name of the carrier.
  *   `labelUri` (*type:* `String.t`, *default:* `nil`) - The URL for the return shipping label in PDF format
  *   `trackingId` (*type:* `String.t`, *default:* `nil`) - The tracking id of this return label.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :carrier => String.t() | nil,
          :labelUri => String.t() | nil,
          :trackingId => String.t() | nil
        }

  field(:carrier)
  field(:labelUri)
  field(:trackingId)
end

defimpl Poison.Decoder, for: GoogleApi.Content.V21.Model.ReturnShippingLabel do
  def decode(value, options) do
    GoogleApi.Content.V21.Model.ReturnShippingLabel.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Content.V21.Model.ReturnShippingLabel do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
