# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V21.Model.SettlementReport do
  @moduledoc """
   Settlement reports detail order-level and item-level credits and debits between you and Google.

  ## Attributes

  *   `endDate` (*type:* `String.t`, *default:* `nil`) - The end date on which all transactions are included in the report, in ISO 8601 format.
  *   `kind` (*type:* `String.t`, *default:* `nil`) - Identifies what kind of resource this is. Value: the fixed string "`content#settlementReport`"
  *   `previousBalance` (*type:* `GoogleApi.Content.V21.Model.Price.t`, *default:* `nil`) - The residual amount from the previous invoice. This is set only if the previous invoices are not paid because of negative balance.
  *   `settlementId` (*type:* `String.t`, *default:* `nil`) - The ID of the settlement report.
  *   `startDate` (*type:* `String.t`, *default:* `nil`) - The start date on which all transactions are included in the report, in ISO 8601 format.
  *   `transferAmount` (*type:* `GoogleApi.Content.V21.Model.Price.t`, *default:* `nil`) - The money due to the merchant.
  *   `transferDate` (*type:* `String.t`, *default:* `nil`) - Date on which transfer for this payment was initiated by Google, in ISO 8601 format.
  *   `transferIds` (*type:* `list(String.t)`, *default:* `nil`) - The list of bank identifiers used for the transfer. e.g. Trace ID for Federal Automated Clearing House (ACH). This may also be known as the Wire ID.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :endDate => String.t() | nil,
          :kind => String.t() | nil,
          :previousBalance => GoogleApi.Content.V21.Model.Price.t() | nil,
          :settlementId => String.t() | nil,
          :startDate => String.t() | nil,
          :transferAmount => GoogleApi.Content.V21.Model.Price.t() | nil,
          :transferDate => String.t() | nil,
          :transferIds => list(String.t()) | nil
        }

  field(:endDate)
  field(:kind)
  field(:previousBalance, as: GoogleApi.Content.V21.Model.Price)
  field(:settlementId)
  field(:startDate)
  field(:transferAmount, as: GoogleApi.Content.V21.Model.Price)
  field(:transferDate)
  field(:transferIds, type: :list)
end

defimpl Poison.Decoder, for: GoogleApi.Content.V21.Model.SettlementReport do
  def decode(value, options) do
    GoogleApi.Content.V21.Model.SettlementReport.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Content.V21.Model.SettlementReport do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
