# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V21.Model.SettlementTransaction do
  @moduledoc """
  Settlement transactions give a detailed breakdown of the settlement report.

  ## Attributes

  *   `amount` (*type:* `GoogleApi.Content.V21.Model.SettlementTransactionAmount.t`, *default:* `nil`) - The amount for the transaction.
  *   `identifiers` (*type:* `GoogleApi.Content.V21.Model.SettlementTransactionIdentifiers.t`, *default:* `nil`) - Identifiers of the transaction.
  *   `kind` (*type:* `String.t`, *default:* `nil`) - Identifies what kind of resource this is. Value: the fixed string "`content#settlementTransaction`"
  *   `transaction` (*type:* `GoogleApi.Content.V21.Model.SettlementTransactionTransaction.t`, *default:* `nil`) - Details of the transaction.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :amount => GoogleApi.Content.V21.Model.SettlementTransactionAmount.t() | nil,
          :identifiers => GoogleApi.Content.V21.Model.SettlementTransactionIdentifiers.t() | nil,
          :kind => String.t() | nil,
          :transaction => GoogleApi.Content.V21.Model.SettlementTransactionTransaction.t() | nil
        }

  field(:amount, as: GoogleApi.Content.V21.Model.SettlementTransactionAmount)
  field(:identifiers, as: GoogleApi.Content.V21.Model.SettlementTransactionIdentifiers)
  field(:kind)
  field(:transaction, as: GoogleApi.Content.V21.Model.SettlementTransactionTransaction)
end

defimpl Poison.Decoder, for: GoogleApi.Content.V21.Model.SettlementTransaction do
  def decode(value, options) do
    GoogleApi.Content.V21.Model.SettlementTransaction.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Content.V21.Model.SettlementTransaction do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
