# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V21.Model.SettlementTransactionIdentifiers do
  @moduledoc """


  ## Attributes

  *   `adjustmentId` (*type:* `String.t`, *default:* `nil`) - The identifier of the adjustments, if it is available.
  *   `merchantOrderId` (*type:* `String.t`, *default:* `nil`) - The merchant provided order ID.
  *   `orderItemId` (*type:* `String.t`, *default:* `nil`) - The identifier of the item.
  *   `settlementEntryId` (*type:* `String.t`, *default:* `nil`) - The unique ID of the settlement transaction entry.
  *   `shipmentIds` (*type:* `list(String.t)`, *default:* `nil`) - The shipment ids for the item.
  *   `transactionId` (*type:* `String.t`, *default:* `nil`) - The Google transaction ID.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :adjustmentId => String.t() | nil,
          :merchantOrderId => String.t() | nil,
          :orderItemId => String.t() | nil,
          :settlementEntryId => String.t() | nil,
          :shipmentIds => list(String.t()) | nil,
          :transactionId => String.t() | nil
        }

  field(:adjustmentId)
  field(:merchantOrderId)
  field(:orderItemId)
  field(:settlementEntryId)
  field(:shipmentIds, type: :list)
  field(:transactionId)
end

defimpl Poison.Decoder, for: GoogleApi.Content.V21.Model.SettlementTransactionIdentifiers do
  def decode(value, options) do
    GoogleApi.Content.V21.Model.SettlementTransactionIdentifiers.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Content.V21.Model.SettlementTransactionIdentifiers do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
