# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V21.Model.Table do
  @moduledoc """


  ## Attributes

  *   `columnHeaders` (*type:* `GoogleApi.Content.V21.Model.Headers.t`, *default:* `nil`) - Headers of the table's columns. Optional: if not set then the table has only one dimension.
  *   `name` (*type:* `String.t`, *default:* `nil`) - Name of the table. Required for subtables, ignored for the main table.
  *   `rowHeaders` (*type:* `GoogleApi.Content.V21.Model.Headers.t`, *default:* `nil`) - Headers of the table's rows. Required.
  *   `rows` (*type:* `list(GoogleApi.Content.V21.Model.Row.t)`, *default:* `nil`) - The list of rows that constitute the table. Must have the same length as `rowHeaders`. Required.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :columnHeaders => GoogleApi.Content.V21.Model.Headers.t() | nil,
          :name => String.t() | nil,
          :rowHeaders => GoogleApi.Content.V21.Model.Headers.t() | nil,
          :rows => list(GoogleApi.Content.V21.Model.Row.t()) | nil
        }

  field(:columnHeaders, as: GoogleApi.Content.V21.Model.Headers)
  field(:name)
  field(:rowHeaders, as: GoogleApi.Content.V21.Model.Headers)
  field(:rows, as: GoogleApi.Content.V21.Model.Row, type: :list)
end

defimpl Poison.Decoder, for: GoogleApi.Content.V21.Model.Table do
  def decode(value, options) do
    GoogleApi.Content.V21.Model.Table.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Content.V21.Model.Table do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
