# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V21.Model.TestOrderPickupDetails do
  @moduledoc """


  ## Attributes

  *   `locationCode` (*type:* `String.t`, *default:* `nil`) - Required. Code of the location defined by provider or merchant.
  *   `pickupLocationAddress` (*type:* `GoogleApi.Content.V21.Model.TestOrderAddress.t`, *default:* `nil`) - Required. Pickup location address.
  *   `pickupLocationType` (*type:* `String.t`, *default:* `nil`) - Pickup location type. Acceptable values are: - "`locker`" - "`store`" - "`curbside`" 
  *   `pickupPersons` (*type:* `list(GoogleApi.Content.V21.Model.TestOrderPickupDetailsPickupPerson.t)`, *default:* `nil`) - Required. all pickup persons set by users.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :locationCode => String.t() | nil,
          :pickupLocationAddress => GoogleApi.Content.V21.Model.TestOrderAddress.t() | nil,
          :pickupLocationType => String.t() | nil,
          :pickupPersons =>
            list(GoogleApi.Content.V21.Model.TestOrderPickupDetailsPickupPerson.t()) | nil
        }

  field(:locationCode)
  field(:pickupLocationAddress, as: GoogleApi.Content.V21.Model.TestOrderAddress)
  field(:pickupLocationType)

  field(:pickupPersons,
    as: GoogleApi.Content.V21.Model.TestOrderPickupDetailsPickupPerson,
    type: :list
  )
end

defimpl Poison.Decoder, for: GoogleApi.Content.V21.Model.TestOrderPickupDetails do
  def decode(value, options) do
    GoogleApi.Content.V21.Model.TestOrderPickupDetails.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Content.V21.Model.TestOrderPickupDetails do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
