# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V21.Model.WarehouseCutoffTime do
  @moduledoc """


  ## Attributes

  *   `hour` (*type:* `integer()`, *default:* `nil`) - Required. Hour (24-hour clock) of the cutoff time until which an order has to be placed to be processed in the same day by the warehouse. Hour is based on the timezone of warehouse.
  *   `minute` (*type:* `integer()`, *default:* `nil`) - Required. Minute of the cutoff time until which an order has to be placed to be processed in the same day by the warehouse. Minute is based on the timezone of warehouse.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :hour => integer() | nil,
          :minute => integer() | nil
        }

  field(:hour)
  field(:minute)
end

defimpl Poison.Decoder, for: GoogleApi.Content.V21.Model.WarehouseCutoffTime do
  def decode(value, options) do
    GoogleApi.Content.V21.Model.WarehouseCutoffTime.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Content.V21.Model.WarehouseCutoffTime do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
